class Condition {
    constructor(target, shieldFilter = false, rangeFilter = false, shield, range) { //shieldFilter : true/false - rangeFilter : true/false
        this.shieldFilter = shieldFilter;
        this.rangeFilter = rangeFilter;
        this.shield = shield;
        this.range = range;
        this.target = target;

        this.lNode = [];
    }

    addNode(node) {
        this.lNode.push(node);
    }

    do(robot) {
        if (this.doCondition(robot)) {
            for (let i = 0; i < this.lNode.length; i++) {
                if (this.lNode[i].do(robot)) {
                    return true;
                }
            }
        }
        return false;
    }

    doCondition(robot) {
        if (this.shieldFilter) {
            if (this.shieldCondition()) {
                if (this.rangeFilter) {
                    return this.rangeCondition(robot);
                }
                return true;
            }
        } else if (this.rangeFilter) {
            return this.rangeCondition(robot);
        }
        return false;
    }

    rangeCondition(robot) {
        return robot.calcDistance(this.target) <= this.range;
    }

    shieldCondition() {
        if (this.target.shield.value / this.target.shield.valueMax <= this.shield) {
            return true;
        }
        return false;
    }

    clearNodes() {
        this.lNode = [];
    }


    moveToward(robot) {
        return robot.advanceToTarget();
    }

    fleeFrom(robot) {
        return robot.fleeFromTarget();
    }
}